/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "mystatusbar.h"
#include "sopfork.h"
#include <qlabel.h>
//Added by qt3to4:
#include <QMouseEvent>
#include <QEvent>

enum {
    CONNECT,
    HOOK
};

MyStatusBar::MyStatusBar(QWidget * parent,
			 const char *name):QStatusBar(parent, name),
sopfork(static_cast < SopFork * >(parent))
{
    message_label[0] = new QLabel(this);
    addWidget(message_label[0], 1, 0);
    for (int i = 1; i < 6; i++) {
	message_label[i] = new QLabel(this);
	message_label[i]->hide();
    }

    flag_state = CONNECT;
}

//-----------------------------------------------------------------
void MyStatusBar::showMessage(QString str)
{
    if (flag_state == HOOK) {
	for (int i = 1; i < 6; i++) {
	    removeWidget(message_label[i]);
	    message_label[i]->hide();
	}
	flag_state = CONNECT;
    }
    message_label[0]->setText(str);
}

void MyStatusBar::showMessage(QString str[6])
{
    if (flag_state == CONNECT) {
	for (int i = 1; i < 6; i++) {
	    addWidget(message_label[i], 1, 0);
	    message_label[i]->show();
	}
	flag_state = HOOK;
    }
    for (int i = 0; i < 6; i++)
	message_label[i]->setText(str[i]);

}

//-----------------------------------------------------------------
void MyStatusBar::mousePressEvent(QMouseEvent *)
{
    message(sopfork->channelname);
}

void MyStatusBar::mouseReleaseEvent(QMouseEvent *)
{
    clear();
}


void MyStatusBar::leaveEvent(QEvent *)
{
    clear();
}
