/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "header.h"
#include "mainwindow.h"
#include "menubar.h"
#include "channel.h"
#include "pagechannel.h"
#include "tabwidget.h"
//#include "sound.h"
#include <QHBoxLayout>
//Added by qt3to4:

PageChannel::PageChannel (QWidget * parent, const char *name):
Q3VBox (parent, name),
tabwidget (static_cast < TabWidget * >(parent))
{
   buttonchannel = new QToolButton (this);
   buttonchannel->setAutoRaise (true);
   buttonchannel->setUsesTextLabel (true);
   buttonchannel->setToggleButton (TRUE);
   buttonchannel->setTextLabel (tr ("Channel"));

   editsearch = new QLineEdit ("", this);

   buttonsearch = new QToolButton (this);
   buttonsearch->setTextLabel (tr ("Search"));
   buttonsearch->setAutoRaise (true);
   buttonsearch->setUsesTextLabel (true);

   buttonexpand = new QToolButton (this);
   buttonexpand->setTextLabel (tr ("Expand"));
   buttonexpand->setAutoRaise (true);
   buttonexpand->setUsesTextLabel (true);
   ///sound
//   sound = new Sound (this);
//   slidersound =
//      new QSlider (0, 100, 10, sound->volume (), Qt::Horizontal, this);
//   connect (slidersound, SIGNAL (valueChanged (int)), sound, SLOT (volume (int)));


   QWidget *w = new QWidget (this);
   QHBoxLayout *hbox = new QHBoxLayout (w);
   hbox->addWidget (buttonchannel);
   hbox->addWidget (editsearch);
   hbox->addWidget (buttonsearch);
   hbox->addWidget (buttonexpand);
 //  hbox->addWidget (slidersound);
   w->setLayout (hbox);

   channel = new Channel (this);
   connect (buttonchannel, SIGNAL (toggled (bool)), channel,
	    SLOT (onButtonChannelToggled(bool)));

   connect (editsearch, SIGNAL (returnPressed ()), channel,
	    SLOT (onButtonSearchClicked ()));
   connect (buttonsearch, SIGNAL (clicked ()), channel,
	    SLOT (onButtonSearchClicked ()));
   connect (buttonexpand, SIGNAL (clicked ()), channel,
	    SLOT (onButtonExpandClicked ()));

//   QTimer *timer = new QTimer (this);
//   connect (timer, SIGNAL (timeout ()), this, SLOT (timerDone ()));
//   timer->start (1000, FALSE);


}

/*
void
PageChannel::timerDone ()
{
   ///sound
   int value = sound->volume ();
   if (slidersound->value () != value)
      slidersound->setValue (value);
//    ///clock
//    labelclock->setText(QTime::currentTime().toString());
}
*/

