/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "vlcfork.h"
#include "header.h"
#include "tabwidget.h"
#include "menubar.h"
#include "record.h"
#include "pageplay.h"
#include "pagechannel.h"
#include "tabbar.h"
#include "channel.h"
#include "mainwindow.h"
//Added by qt3to4:
#include <QMouseEvent>
#include <QAction>
#include <QVBoxLayout>
TabWidget::TabWidget (QWidget * parent, const char *name):
QTabWidget (parent, name),
mainwindow (static_cast < MainWindow * >(parent))
{
  connect (this, SIGNAL (currentChanged (int)), this, SLOT (onCurrentChanged (int)));

  ///use custom  tabbar
  tabbar = new TabBar (this);
  setTabBar (tabbar);
/*   ///topleft corner widget
   QToolButton *but = new QToolButton (this);
   but->setTextLabel ("p");
   but->setAutoRaise (true);
   but->setUsesTextLabel (true);
   setCornerWidget (but, Qt::TopLeft);
                                       connect (but, SIGNAL (clicked ()), this, SLOT (playTab ()));
*////topright corner widget
  QToolButton *but = new QToolButton (this);
  but->setTextLabel ("x");
  but->setAutoRaise (true);
  but->setUsesTextLabel (true);
  setCornerWidget (but, Qt::TopRight);
  connect (but, SIGNAL (clicked ()), this, SLOT (removeTab ()));

  PageChannel *pagechannel = new PageChannel (this);
  addTab (pagechannel, tr (""));
  setTabToolTip (pagechannel, "channel");
//showPage(channel);
//   setMaximumHeight (sizeHint ().height ());

/*
  QTimer *timer = new QTimer (this);
  connect (timer, SIGNAL (timeout ()), this, SLOT (timerDone ()));
  timer->start (1000, FALSE);
*/

  QAction *a;
  a = new QAction (this);
  a->setShortcut (Qt::CTRL + Qt::Key_W);
  connect (a, SIGNAL (triggered ()), this, SLOT (removeTab ()));
  addAction (a);
}

void
TabWidget::removeTab ()
{
  if (tabToolTip (currentPage ()) == "mplayer" || tabToolTip (currentPage ()) == "vlc")
    {
      PagePlay *pageplay = static_cast < PagePlay * >(currentPage ());
      removePage (pageplay);
      delete pageplay;
    }
}

void
TabWidget::playTab ()
{
  PagePlay *pageplay = new PagePlay (this);
  addTab (pageplay, tr ("play"));
  if (mainwindow->menubar->player_column == VLC)
    setTabToolTip (pageplay, "vlc");
  else
    setTabToolTip (pageplay, "mplayer");
  showPage (pageplay);
//   printf ("%d\n", currentIndex ());
}

void
TabWidget::onCurrentChanged (int currentIndex)
{
  if (currentIndex == 0)
    return;

  for (int i = 1; i < count (); i++)
    if (mainwindow->tabwidget->tabToolTip (mainwindow->tabwidget->widget (i)) == "vlc")
//    if (static_cast < PagePlay * >(widget (i))->fork->isPlaying)
      {
	if (i == currentIndex)
	  {
	    libvlc_audio_set_volume (static_cast < PagePlay * >(widget (i))->vlcfork->mp, 100);
	  }
	else
	  {
	    libvlc_audio_set_volume (static_cast < PagePlay * >(widget (i))->vlcfork->mp, 0);
	  }
      }
}

void
TabWidget::timerDone ()
{
/*  libvlc_exception_t ex;

  for (int i = 1; i < count (); i++)
//    if (static_cast < PagePlay * >(widget (i))->fork->isPlaying)
      {
//	int volume = libvlc_audio_get_volume (static_cast < PagePlay * >(widget (i))->fork->inst, &ex);
int isplaying=libvlc_media_player_is_playing(static_cast<PagePlay*>(widget(i))->fork->mp,&ex);	
	printf ("i=%d,isplaying=%d\n", i, isplaying
			);
      }*/
}


/*
void
TabWidget::recordTab ()
{
   Record *record = new Record (this);
   addTab (record, tr ("record"));
   setTabToolTip (record, "record");
   showPage (record);
}
*/

/*
void
TabWidget::mouseDoubleClickEvent (QMouseEvent * e)
{
   QPoint p (e->pos ());
   QRect pr (rect ());
   pr.setHeight (tabbar->height ());
   //mouse stay outside of tabbar area
   if (!pr.contains (p))
      return;

   if (e->button () == Qt::LeftButton)
      playTab ();
   else if (e->button () == Qt::RightButton)
      recordTab ();
}*/
